package com.engine.kq.cmd.leavetypes;

import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.core.interceptor.CommandContext;
import com.engine.kq.bean.RightMenu;
import com.engine.kq.bean.RightMenuType;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Auther: xiaj
 * @Date: 2019-03-07 16:28
 * @Description: 假期类型--获取右键菜单
 */
public class GetRightMenuCmd extends AbstractCommonCommand<Map<String, Object>> {

    public GetRightMenuCmd(Map<String, Object> params, User user) {
        this.user = user;
        this.params = params;
    }

    @Override
    public BizLogContext getLogContext() {
        return null;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        Map<String, Object> resultMap = new HashMap<String, Object>();
        List<Object> rightMenuList = new ArrayList<Object>();//表示有权限可以看见的菜单List集合
        int languageId = user.getLanguage();//用户选择的语言
        RightMenu rightMenu = null;

        boolean canAdd = HrmUserVarify.checkUserRight("KQLeaveRulesAdd:Add", user);//是否具有新建权限
        boolean canDelete = HrmUserVarify.checkUserRight("KQLeaveRulesDelete:Delete", user);//是否具有删除权限
        boolean canLog = HrmUserVarify.checkUserRight("KQLeaveRules:Log", user);//是否具有查看日志的权限
        if (canAdd) {
            rightMenu = new RightMenu(languageId, RightMenuType.BTN_Addnew, "new", true);//新建
            rightMenuList.add(rightMenu);

            rightMenu = new RightMenu(languageId, RightMenuType.BTN_Save, "save", true);//保存
            rightMenuList.add(rightMenu);
        }
        if(canDelete){
            rightMenu = new RightMenu(languageId, RightMenuType.BTN_BatchDelete, "batchDelete", true, true);//批量删除
            rightMenuList.add(rightMenu);
        }
        if (canLog) {
            rightMenu = new RightMenu(languageId, RightMenuType.BTN_log, "log", false);//日志
            rightMenuList.add(rightMenu);
        }
        rightMenu = new RightMenu(languageId, RightMenuType.BTN_COLUMN, "custom", false); //显示列定制
        rightMenuList.add(rightMenu);
        resultMap.put("btnMenu", rightMenuList);
        return resultMap;
    }
}
